<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<style>
    .div-image{
        background-image: url(images/bg-01.jpg);
        background-repeat: no-repeat;
        background-size: 100%;
        opacity: 0.9;
    }

    ::placeholder{
        text-align: center;
    }
</style>

<body class="hold-transition sidebar-mini layout-fixed div-image">

    <!-- Main content -->
    <div class="container ">
        <div class="row d-flex align-items-center min-vh-100">
            <div class="col-sm-5 text-center mx-auto my-0 jumbotron">
                <div class="mb-5">
                    <h3 class="text-center">Đăng nhập</h3>
                </div>
                <div>
                    <div class="form-group">
                        <input type="text" id="inp-login-username" placeholder="Tên tài khoản" class="form-control">
                    </div>
                    <div class="form-group">
                        <input type="password" id="inp-login-password" placeholder="Mật khẩu" class="form-control">
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-6">
                            <input type="checkbox" id="ckb-remember-account" class="form-check-input">
                            <label class="form-check-label">Ghi nhớ tài khoản</label>
                        </div>
                        <div class="col-sm-6">
                            <a class="float-right" href="#">Quên mật khẩu?</a>
                        </div>
                    </div>
                    <div class="form-group">
                        <button id="btn-log-in-confirm" class="btn btn-log btn-block btn-info">Log
                            In</button>
                    </div>
                </div>
                <div class="text-center"><a href="#" id="register-form">Đăng ký</a> tài khoản mới
                </div>
            </div>
        </div>
    </div>
    <!-- /.content -->

    <!-- Register modal -->
    <div id="register-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header bg-success">
                    <h5 class="modal-title">Đăng ký</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <div class="row form-group">
                        <div class="col-6 form-group">
                            <input id="inp-register-first-name" class="form-control" placeholder="Họ">
                        </div>
                        <div class="col-6 form-group">
                            <input id="inp-register-last-name" class="form-control" placeholder="Tên">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4 text-left">
                            <label>Địa chỉ</label>
                        </div>
                        <div class="col-md-8 form-group">
                            <input id="inp-register-address" class="form-control" placeholder="Nhập địa chỉ">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4 text-left">
                            <label>Email</label>
                        </div>
                        <div class="col-md-8 form-group">
                            <input id="inp-register-email" class="form-control" placeholder="Nhập Email">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4 text-left">
                            <label>Tên tài khoản<i class="text-danger">*</i></label>
                        </div>
                        <div class="col-md-8 form-group">
                            <input id="inp-register-username" class="form-control" placeholder="Nhập tên tài khoản">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4 text-left">
                            <label>Mật khẩu<i class="text-danger">*</i></label>
                        </div>
                        <div class="col-md-8 form-group">
                            <input id="inp-register-password" type="password" class="form-control"
                                placeholder="Nhập mật khẩu">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4 text-left">
                            <label>Nhập lại mật khẩu<i class="text-danger">*</i></label>
                        </div>
                        <div class="col-md-8 form-group">
                            <input id="inp-register-confirm-password" type="password" class="form-control"
                                placeholder="Nhập lại mật khẩu">
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-register-confirm">Đăng ký</button>
                    <button class="btn btn-secondary" id="btn-register-cancel" data-dismiss="modal">Huỷ</button>
                </div>
            </div>
        </div>
    </div>

    </div>

    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {

            const ckbRememberAccount = document.getElementById("ckb-remember-account"),
                inpUserName = document.getElementById("inp-login-username");

            if (localStorage.checkbox && localStorage.checkbox !== "") {
                ckbRememberAccount.setAttribute("checked", "checked");
                inpUserName.value = localStorage.username;
            } else {
                ckbRememberAccount.removeAttribute("checked");
                inpUserName.value = "";
            }

            var gEmployees = [];
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            $("#register-form").on("click", function () {
                $("#register-modal").modal("show");
            })

            $("#btn-log-in-confirm").on("click", function () {
                onBtnLogInConfirmClick();
            });

            $("#btn-register-confirm").on("click", function () {
                onBtnRegisterConfirmClick();
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                callApiGetAllEmployees();
            }
            function onBtnLogInConfirmClick() {
                "use strict";
                var vLogInData = {
                    username: "",
                    password: "",
                }
                if (ckbRememberAccount.checked && inpUserName.value !== "") {
                    localStorage.username = inpUserName.value;
                    localStorage.checkbox = ckbRememberAccount.value;
                } else {
                    localStorage.username = "";
                    localStorage.checkbox = "";
                }
                // B1: Thu thập dữ liệu
                getLogInData(vLogInData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateLogInData(vLogInData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiLogInUser(vLogInData);
                }
            }

            function onBtnRegisterConfirmClick() {
                "use strict";
                var vRegisterData = {
                    firstName: "",
                    lastName: "",
                    address: "",
                    email: "",
                    username: "",
                    password: "",
                }
                // B1: Thu thập dữ liệu
                var vConfirmPasswordValue = $("#inp-register-confirm-password").val().trim();
                getRegisterData(vRegisterData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateRegisterData(vRegisterData, vConfirmPasswordValue);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiRegisterUser(vRegisterData);
                    $("#register-modal").modal("hide");
                }
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */

            // Hàm gọi api lấy tất cả employee
            function callApiGetAllEmployees() {
                $.ajax({
                    url: "http://localhost:8080/employees",
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        gEmployees = paramResponseObj;
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function getLogInData(paramUserData) {
                paramUserData.username = $("#inp-login-username").val().trim();
                paramUserData.password = $("#inp-login-password").val().trim();
            }

            function getRegisterData(paramUserData) {
                paramUserData.firstName = $("#inp-register-first-name").val().trim();
                paramUserData.lastName = $("#inp-register-last-name").val().trim();
                paramUserData.address = $("#inp-register-address").val().trim();
                paramUserData.email = $("#inp-register-email").val().trim();
                paramUserData.username = $("#inp-register-username").val().trim();
                paramUserData.password = $("#inp-register-password").val().trim();
            }

            function validateLogInData(paramUserData) {
                if (paramUserData.username == "") {
                    alertError("User Name không được để trống");
                    return false;
                }
                if (paramUserData.password == "") {
                    alertError("Password không được để trống");
                    return false;
                }
                return true;
            }

            function validateRegisterData(paramUserData, paramConfirmPassword) {
                if (paramUserData.firstName == "") {
                    alertError("First Name không được để trống");
                    return false;
                }
                if (paramUserData.lastName == "") {
                    alertError("Last Name không được để trống");
                    return false;
                }
                if (paramUserData.email == "") {
                    alertError("Email không được để trống.");
                    return false;
                }
                for (let i = 0; i < gEmployees.length; i++) {
                    if (paramUserData.username == gEmployees[i].username) {
                        alertError("User Name đã tồn tại.");
                        return false;
                    }
                }
                if (paramUserData.username == "") {
                    alertError("User Name không được để trống.");
                    return false;
                }
                if (paramUserData.password == "") {
                    alertError("Password không được để trống");
                    return false;
                }
                if (paramConfirmPassword != paramUserData.password) {
                    alertError("Confirm Password không đúng");
                    return false;
                }
                return true;
            }

            function callApiLogInUser(paramUserData) {
                $.ajax({
                    url: "http://localhost:8080/login",
                    method: "POST",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUserData),
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        responseHandler(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Đăng nhập không thành công.");
                    }
                });
            }

            function callApiRegisterUser(paramUserData) {
                $.ajax({
                    url: "http://localhost:8080/register",
                    method: "POST",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUserData),
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Đăng ký thành công.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Đăng ký không thành công.");
                    }
                });
            }

            //Xử lý object trả về khi login thành công
            function responseHandler(data) {
                //Lưu token vào cookie trong 1 ngày
                setCookie("token", data, 1);

                callApiGetUserIdByToken(data);

            }

            //Hàm setCookie đã giới thiệu ở bài trước
            function setCookie(cname, cvalue, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toUTCString();
                document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
            }

            function callApiGetUserIdByToken(paramToken) {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + paramToken,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        handlerEmployeeDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerEmployeeDataResponse(paramEmployeeData) {
                //debugger
                if (paramEmployeeData.roles[0].id == 2) {
                    window.location.href = "realestate.html";
                }
                else if (paramEmployeeData.roles[0].id == 3) {
                    window.location.href = "realestate1.html";
                }
                else if (paramEmployeeData.roles[0].id == 4) {
                    window.location.href = "../CustomerFrontEnd/index.html";
                }
            }

            // Hàm alert success
            function alertSuccess(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'success',
                        title: paramTitle,
                    })
                });
            }

            // Hàm alert lỗi
            function alertError(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'error',
                        title: paramTitle,
                    })
                });
            }


        });

    </script>
</body>